package de.jmstest;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import javax.ejb.Singleton;
import javax.ejb.Startup;
import javax.ejb.Timeout;
import javax.ejb.Timer;
import javax.ejb.TimerService;
import javax.jms.BytesMessage;
import javax.jms.ConnectionFactory;
import javax.jms.DeliveryMode;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicPublisher;
import javax.jms.TopicSession;
import javax.naming.InitialContext;
import javax.naming.NamingException;

@Startup
@Singleton

public class Producer  {
	
	TopicConnection conn = null;
    TopicSession session = null;
    Topic topic = null;
    
    static int counter = 0; 
    
    static int tick = 30; 
    
    static int messages = 500; 
    
    static long ticketnr = System.currentTimeMillis()%10000;
    

    @Resource
    TimerService timerService;	
	
    @PostConstruct 
	public void initTimer() {
    	System.out.println("----------------------------------------------------------------------------------------");
			    System.out.println("create  new timer");
			    Timer timer = timerService.createTimer(1000, 
		                "JMSTimer");
			    System.out.println("----------------------------------------------------------------------------------------");


	}
    
    String text ="TEST LARGE MESSAGE MENORY CONSUMPTION";
	
	@Timeout
    public void testLargeFile(Timer timer) {
	    tick--;
	    
	    System.out.println("Countdown  230 MB Test  " + tick);
	     
	    if ( tick == 0 ) { 
	    	try { 
         long start =System.currentTimeMillis();
         for ( int i= 1; i <= 10; i++) {    
		 InitialContext iniCtx = new InitialContext();
		    Object tmp = iniCtx.lookup("ConnectionFactory");
		    TopicConnectionFactory tcf = (TopicConnectionFactory) tmp;
		    conn = tcf.createTopicConnection();
		    topic = (Topic) iniCtx.lookup("java:/topic/TOPIC_PERSISTENT");
		    session = conn.createTopicSession(true,
		                                      TopicSession.SESSION_TRANSACTED);
		    
		    
		    MessageProducer send = session.createProducer(topic);
		    send.setDeliveryMode(DeliveryMode.PERSISTENT);

		    

		    counter++;
		    

		    FileOutputStream fout = new FileOutputStream("test.dat");
		    int count =  230* 1024*1024/text.length();
		    while ( count > 0 ) { 
		    	fout.write(text.getBytes());
		    	count--;
		    }
		    fout.close(); 
		    ticketnr++; 
	        BytesMessage message = session.createBytesMessage();
			message.setStringProperty("INFO", "FILE NO " + Integer.toString(i));
			message.setObjectProperty("JMS_HQ_InputStream",
					new BufferedInputStream(new FileInputStream("test.dat"), 8192));

		    
            System.out.println("send " + i);
	        send.send(message);
	    	File f = new File("test.dat");
	    	f.delete();

		    session.commit();
		    session.close();
		    conn.close();

		    }
		    System.out.println("------------------------------------");
		    System.out.println("Messages Send " + counter);
		    System.out.println("------------------------------------");
	    	}
	    	catch(Exception e ) { 
	    		e.printStackTrace();
	    	}
	    }
	    else { 
	    	  if ( tick>0 ) {
	    		  Timer newtimer = timerService.createTimer(1000,      "JMSTimer"); 
	    	  }
		          
			 
	    }


	}
	
		
	
	
    }
